=== debian/changelog ===
di (4.54.0.1-1) unstable; urgency=medium

  * New upstream version 4.54.0.1

 -- Michael Ablassmeier <abi@debian.org>  Tue, 15 Oct 2024 12:41:26 +0200

di (4.54-1) unstable; urgency=medium

  * New upstream version 4.54
  * Bump standards version

 -- Michael Ablassmeier <abi@debian.org>  Mon, 14 Oct 2024 21:23:33 +0200
