=== debian/control ===
Source: di
Section: utils
Priority: optional
Maintainer: Michael Ablassmeier <abi@debian.org>
Build-Depends: debhelper (>= 13), debhelper-compat (=13), gettext
Standards-Version: 4.7.0
Homepage: https://diskinfo-di.sourceforge.io/
Vcs-Git: https://salsa.debian.org/debian/di.git
Vcs-Browser: https://salsa.debian.org/debian/di
Rules-Requires-Root: no

Package: di
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: advanced df like disk information utility
 `di' is a disk information utility, displaying everything
 (and more) that your `df' command does. It features the
 ability to display your disk usage in whatever format you
 desire/prefer/are used to. It is designed to be portable
 across many platforms.
