## di 5.0.6

=== CMakeLists.txt ===
#
# Copyright 2025 Brad Lanam Pleasant Hill CA
#
cmake_minimum_required (VERSION 3.13)

# avoid msys2/windows issue
set (CMAKE_C_COMPILER_WORKS 1)

###
# load the DI_* variables from VERSION.txt

file (STRINGS VERSION.txt tdivars)
foreach (tvar IN LISTS tdivars)
  # the export lines are not needed
  if (tvar MATCHES "=")
    string (REGEX MATCH "^[^=]*" tnm ${tvar})
    string (REGEX MATCH "=.*" tvala ${tvar})
    string (REPLACE "=" "" tval ${tvala})
    set (${tnm} ${tval})
  endif()
endforeach()

###
# also set DI_USE_MATH from the environment if there
if (DEFINED ENV{DI_USE_MATH})
  set (DI_USE_MATH $ENV{DI_USE_MATH})
  # these are the only supported values as of 2025-2-6
  if (NOT DI_USE_MATH STREQUAL "DI_INTERNAL" AND
      NOT DI_USE_MATH STREQUAL "DI_GMP" AND
      NOT DI_USE_MATH STREQUAL "DI_TOMMATH")
    unset (DI_USE_MATH)
  endif()
endif()

if (NOT DEFINED DI_BUILD_SYS OR DI_BUILD_SYS STREQUAL "")
  set (DI_BUILD_SYS cmake)
endif()

###
# check to make sure cmake-install-prefix is set
if (NOT DEFINED CMAKE_INSTALL_PREFIX OR CMAKE_INSTALL_PREFIX STREQUAL "")
  message (FATAL_ERROR "CMAKE_INSTALL_PREFIX is not set")
endif()

project (DI
  VERSION ${DI_VERSION}
  DESCRIPTION "di - disk information utility"
  HOMEPAGE_URL "https://diskinfo-di.sourceforge.io"
  LANGUAGES C
)
option (BUILD_SHARED_LIBS "Build dynamic library" ON)

set (default_build_type "Release")

include (GNUInstallDirs)

set (DI_LIBNAME libdi)

SET (CMAKE_SKIP_BUILD_RPATH FALSE)
SET (CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

if (DEFINED ENV{CMAKE_SKIP_RPATH} AND NOT ENV{CMAKE_SKIP_RPATH} STREQUAL "")
  set (CMAKE_SKIP_RPATH "$ENV{CMAKE_SKIP_RPATH}")
endif()

include (CheckCCompilerFlag)
include (CheckLinkerFlag)
include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckLinkerFlag)
include (CheckStructHasMember)
include (CheckSymbolExists)
include (CheckTypeSize)
include (CheckVariableExists)
include (CheckPrototypeDefinition)

# MacOS cmake uses a path for the compiler that doesn't
# have the proper include paths built in.
# /Library/Developer/CommandLineTools/usr/bin/cc
# I consider this a bug.
# I don't know what the path for the xcode compiler is, but it
# probably starts with /Library/Developer
# this is only used for getting the xdc member types, so
# it doesn't matter much which compiler, just need one that works.
set (MYCC ${CMAKE_C_COMPILER})
if (APPLE AND ${CMAKE_C_COMPILER} MATCHES "^/Library/Developer/")
  set (MYCC /usr/bin/clang)
endif()

#### compile options

macro (checkAddCompileFlag flag)
  # cmake caches every damned variable...
  # need a different variable for every test.
  check_c_compiler_flag (${flag} cfchk${flag})
  if (cfchk${flag})
    add_compile_options (${flag})
  endif()
endmacro()

macro (checkAddLinkFlag flag)
  check_linker_flag ("C" ${flag} lfchk${flag})
  if (lfchk${flag})
    add_link_options (${flag})
  endif()
endmacro()

checkAddCompileFlag ("-fPIC")
checkAddLinkFlag ("-fPIC")

checkAddCompileFlag ("-Wall")
checkAddCompileFlag ("-Wextra")
checkAddCompileFlag ("-Wconversion")
checkAddCompileFlag ("-Wno-unused-but-set-variable")
checkAddCompileFlag ("-Wno-unused-parameter")
checkAddCompileFlag ("-Wno-unknown-pragmas")
checkAddCompileFlag ("-Wno-float-equal")
checkAddCompileFlag ("-Wformat")
checkAddCompileFlag ("-Wformat-security")
checkAddCompileFlag ("-Werror=format-security")
checkAddCompileFlag ("-Werror=return-type")
checkAddCompileFlag ("-Wdeprecated-declarations")
checkAddCompileFlag ("-Wunreachable-code")

# these don't work w/c++
checkAddCompileFlag ("-Wdeclaration-after-statement")
checkAddCompileFlag ("-Wmissing-prototypes")

#### compiler-specific compile options

checkAddCompileFlag ("-Wmaybe-uninitialized")
checkAddCompileFlag ("-Wno-unused-but-set-variable")
checkAddCompileFlag ("-Wno-stringop-overflow")
checkAddCompileFlag ("-Wno-stringop-truncation")
checkAddCompileFlag ("-Wno-format-truncation")
checkAddCompileFlag ("-Wno-extra-semi-stmt")
checkAddCompileFlag ("-Wno-poison-system-directories")
checkAddCompileFlag ("-Wno-shift-sign-overflow")
checkAddCompileFlag ("-Wno-pragma-pack")
checkAddCompileFlag ("-Wno-ignored-attributes")
checkAddCompileFlag ("-Wno-reserved-macro-identifier")
checkAddCompileFlag ("-Wno-reserved-id-macro")
checkAddCompileFlag ("-Wno-implicit-int-conversion")
checkAddCompileFlag ("-Wno-switch-enum")
checkAddCompileFlag ("-Wno-gnu-zero-variadic-macro-arguments")
checkAddCompileFlag ("-Wno-documentation-deprecated-sync")
checkAddCompileFlag ("-Wno-documentation-unknown-command")
checkAddCompileFlag ("-Wno-documentation")
checkAddCompileFlag ("-Wno-unsafe-buffer-usage")
# llvm-19 creating errors about *printf
checkAddCompileFlag ("-Wno-used-but-marked-unused")

###
# LFS_CFLAGS, LFS_LDFLAGS, LFS_LIBS

macro (applygetconfflags which)
  execute_process (
    OUTPUT_VARIABLE lfs${which}
    ERROR_QUIET
    COMMAND getconf LFS_${which}
    COMMAND tr -d "\n"
  )
  separate_arguments (lfsl${which} UNIX_COMMAND ${lfs${which}})
  if (DEFINED lfs${which} AND NOT lfs${which} STREQUAL "")
    message ("-- getconf: ${which}: ${lfs${which}}")
    foreach (tvar IN LISTS lfsl${which})
      if (${which} STREQUAL "CFLAGS")
        add_compile_options (${tvar})
      endif()
      if (${which} STREQUAL "LDFLAGS")
        add_link_options (${tvar})
      endif()
      if (${which} STREQUAL "LIBS")
        # extremely rare, if ever
        link_libraries (${tvar})
      endif()
    endforeach()
  endif()
endmacro()

message ("-- Getting LFS flags via getconf")
applygetconfflags ("CFLAGS")
applygetconfflags ("LDFLAGS")
applygetconfflags ("LIBS")

#### build compile options

if (NOT DEFINED DI_BUILD OR DI_BUILD STREQUAL "")
  set (DI_BUILD "Release")
endif()

if (DI_BUILD STREQUAL "Release")
  add_compile_options (-O2)
endif()

if (DI_BUILD STREQUAL "Debug")
  add_compile_options (-O0)
endif()

add_compile_options (-g)
add_link_options (-g)

#### more compile options: fortification/address sanitizer

set (DI_FORTIFY Y)
if (DEFINED ENV{DI_FORTIFY} AND NOT ENV{DI_FORTIFY} STREQUAL "")
  set (DI_FORTIFY $ENV{DI_FORTIFY})
endif()

# address sanitizer
if (DI_BUILD STREQUAL "SanitizeAddress")
  set (DI_FORTIFY N)
  add_compile_options (-O0)
  checkAddCompileFlag ("-ggdb")
  add_link_options (-g)
  checkAddCompileFlag ("-fsanitize=address")
  checkAddLinkFlag ("-fsanitize=address")
  checkAddCompileFlag ("-fsanitize-address-use-after-scope")
  checkAddLinkFlag ("-fsanitize-address-use-after-scope")
  checkAddCompileFlag ("-fsanitize-recover=address")
  checkAddLinkFlag ("-fsanitize-recover=address")
  checkAddCompileFlag ("-fno-omit-frame-pointer")
  checkAddCompileFlag ("-fno-common")
  checkAddCompileFlag ("-fno-inline")
  if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    # the gnu C compiler needs this library for the sanitizer
    # other compilers should not link it in.
    checkAddLinkFlag ("-lrt")
  endif()
endif()

# on solaris, the flags are accepted, but the link fails.
if (DI_FORTIFY STREQUAL Y AND NOT CMAKE_HOST_SOLARIS)
  # hardening
  checkAddCompileFlag ("-fstack-protector-strong")
  checkAddCompileFlag ("-fstack-protector-all")
  add_compile_options ("-D_FORTIFY_SOURCE=2")
else()
  checkAddCompileFlag ("-Wno-macro-redefined")
  add_compile_options ("-U_FORTIFY_SOURCE")
  add_compile_options ("-D_FORTIFY_SOURCE=0")
endif()

#### system specific compile options

if (NOT WIN32)
  SET (CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
  if (NOT APPLE)
#    SET (CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR} "\${ORIGIN}")
  endif()
  if (APPLE)
#    SET (CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR} "@loader_path")
    # 10.6 = Snow Leopard, 10.7 = Lion
    # 10.8 = Mountain Lion, 10.9 = Mavericks
    # 10.10 = Yosemite, 10.11 = El Capitan
    # 10.12 = Sierra, 10.13 = High Sierra
    # 10.14 = Mojave, 10.15 = Catalina
    # 11 = Big Sur, 12 = Monterey,
    # 13 = Ventura, 14 = Sonoma
    # 15 = Sequoia
    # set (CMAKE_OSX_ARCHITECTURES "arm64;x86_64")
  endif()
else()
  add_link_options (-static-libgcc)
  add_link_options (-static-libstdc++)
endif()

#### include paths

include_directories (
  SYSTEM
  # for macos
  /opt/local/include
  # for freebsd
  /usr/local/include
  "${CMAKE_BINARY_DIR}"
  "${PROJECT_SOURCE_DIR}/include"
)

set (required_includes
  # for macos
  /opt/local/include
  # for freebsd
  /usr/local/include
)

set (CMAKE_REQUIRED_INCLUDES ${required_includes})
add_compile_options (-DWIN32_LEAN_AND_MEAN=1)

#### configuration

find_package (PkgConfig)
find_package (Intl)
find_package (Iconv)

pkg_check_modules (GMP gmp)
pkg_check_modules (TOMMATH libtommath)
pkg_check_modules (TIRPC libtirpc)

###
# macros for capability testing

macro (checkPrototype_quotactl hdr)
  # this fails when using the c++ compiler.
  # the c++ compiler is only needed on Haiku,
  # but it would be nice to be able to test it elsewhere
  # the mkconfig suite can be used to test c++.
  check_prototype_definition (quotactl
    "int quotactl (const char * a, int b, int c, void * d)"
    0
    "${hdr}"
    _quotactl_pos_1a
    )
  # OpenBSD has char *, but caddr_t works...
  #  "int quotactl (const char *path, int cmd, int id, char *addr)"
  check_prototype_definition (quotactl
    "int quotactl (const char * a, int b, int c, caddr_t d)"
    0
    "${hdr}"
    _quotactl_pos_1b
    )
  check_prototype_definition (quotactl
    "int quotactl (int a, const char * b, int c, caddr_t d)"
    0
    "${hdr}"
    _quotactl_pos_2a
    )
  # alpine linux
  check_prototype_definition (quotactl
    "int quotactl (int a, const char * b, int c, char *d)"
    0
    "${hdr}"
    _quotactl_pos_2b
    )
  if (_quotactl_pos_1a OR _quotactl_pos_1b)
    set (_quotactl_pos_1 1)
  endif()
  if (_quotactl_pos_2a OR _quotactl_pos_2b)
    set (_quotactl_pos_2 1)
  endif()
  if (_quotactl_pos_1)
    set (_c_arg_2_quotactl "int")
    set (_args_quotactl 4)
  endif()
  if (_quotactl_pos_2)
    set (_c_arg_2_quotactl "const char *")
    set (_args_quotactl 4)
  endif()
endmacro()

macro (checkPrototype_statfs hdr)
  check_prototype_definition (statfs
    "int statfs (const char * a, struct statfs * b)"
    0
    "${hdr}"
    _args_statfs_2
    )
  check_prototype_definition (statfs
    "int statfs (const char * a, struct statfs * b, int c)"
    0
    "${hdr}"
    _args_statfs_3
    )
  check_prototype_definition (statfs
    "int statfs (const char * a, struct statfs * b, int c, int d)"
    0
    "${hdr}"
    _args_statfs_4
    )
  if (_args_statfs_2)
    set (_args_statfs 2)
  endif()
  if (_args_statfs_3)
    set (_args_statfs 3)
  endif()
  if (_args_statfs_4)
    set (_args_statfs 4)
  endif()
endmacro()

macro (checkMember_statfs hdr)
  check_struct_has_member ("struct statfs" f_bsize
      "${hdr}" _mem_struct_statfs_f_bsize)
  check_struct_has_member ("struct statfs" f_fsize
      "${hdr}" _mem_struct_statfs_f_fsize)
  check_struct_has_member ("struct statfs" f_fstyp
      "${hdr}" _mem_struct_statfs_f_fstyp)
  check_struct_has_member ("struct statfs" f_iosize
      "${hdr}" _mem_struct_statfs_f_iosize)
  check_struct_has_member ("struct statfs" f_frsize
      "${hdr}" _mem_struct_statfs_f_frsize)
  check_struct_has_member ("struct statfs" f_fstypename
      "${hdr}" _mem_struct_statfs_f_fstypename)
  check_struct_has_member ("struct statfs" mount_info
      "${hdr}" _mem_struct_statfs_mount_info)
  check_struct_has_member ("struct statfs" f_type
      "${hdr}" _mem_struct_statfs_f_type)
endmacro()

macro (checkPrototype_setmntent hdr)
  check_prototype_definition (setmntent
    "FILE * setmntent (const char * a)"
    "NULL"
    "stdio.h;stddef.h;${hdr}"
    _args_setmntent_1
    )
  check_prototype_definition (setmntent
    "FILE * setmntent (const char * a, const char * b)"
    "NULL"
    "stdio.h;stddef.h;${hdr}"
    _args_setmntent_2
    )
  if (_args_setmntent_1)
    set (_args_setmntent 1)
  endif()
  if (_args_setmntent_2)
    set (_args_setmntent 2)
  endif()
endmacro()

macro (checkPrototype_getfsstat hdr)
