=== debian/changelog ===
di (5.0.6-1) unstable; urgency=medium

  * New upstream version 5.0.6

 -- Michael Ablassmeier <abi@debian.org>  Tue, 11 Feb 2025 09:53:22 +0100

di (5.0.5-1) unstable; urgency=medium

  * New upstream version 5.0.5

 -- Michael Ablassmeier <abi@debian.org>  Mon, 10 Feb 2025 09:53:20 +0100

di (5.0.4-1) unstable; urgency=medium

  * New upstream version 5.0.4
  * Split package into libdi/libdi-dev and executable.

 -- Michael Ablassmeier <abi@debian.org>  Fri, 07 Feb 2025 23:05:50 +0100
