=== debian/control ===
--- 
+++ 
@@ -2,7 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Michael Ablassmeier <abi@debian.org>
-Build-Depends: debhelper (>= 13), debhelper-compat (=13), gettext
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (=13),
+               cmake,
+               gettext,
+               libtirpc-dev,
+               libtommath-dev,
+               pkgconf
 Standards-Version: 4.7.0
 Homepage: https://diskinfo-di.sourceforge.io/
 Vcs-Git: https://salsa.debian.org/debian/di.git
@@ -18,3 +24,21 @@
  ability to display your disk usage in whatever format you
  desire/prefer/are used to. It is designed to be portable
  across many platforms.
+
+Package: libdi-dev
+Architecture: any
+Depends: libdi5 (= ${binary:Version}), ${misc:Depends}
+Section: libdevel
+Description: Header files for libdi
+ Development files for libdi, a shared library that can be used to get disk
+ space or percentages.
+
+Package: libdi5
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Section: libs
+Description: Common libraries for di
+ The libdi package provides the shared libraries for the advanced
+ disk information utility
