=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	$(MAKE) COMP=$(CC) PREFIX=$(CURDIR)/debian/di/usr/ CMAKE_SKIP_RPATH=TRUE cmake-unix

override_dh_auto_build:
	dh_auto_build -- cmake-build

override_dh_auto_install:

override_dh_auto_test:

override_dh_auto_clean:
	dh_auto_clean
	rm -f dioptions.dat
