## di 5.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -75,17 +75,22 @@
 include (CheckVariableExists)
 include (CheckPrototypeDefinition)
 
-# MacOS cmake uses a path for the compiler that doesn't
-# have the proper include paths built in.
-# /Library/Developer/CommandLineTools/usr/bin/cc
-# I consider this a bug.
-# I don't know what the path for the xcode compiler is, but it
-# probably starts with /Library/Developer
-# this is only used for getting the xdc member types, so
-# it doesn't matter much which compiler, just need one that works.
-set (MYCC ${CMAKE_C_COMPILER})
-if (APPLE AND ${CMAKE_C_COMPILER} MATCHES "^/Library/Developer/")
-  set (MYCC /usr/bin/clang)
+if (APPLE)
+  # MacOS cmake uses a path for the compiler that doesn't
+  # have the proper include paths built in.  /usr/bin/clang
+  # works with command line tools, but apparently not for xcode.
+  # if the SDKROOT environment variable is not set, set it.
+  if (NOT DEFINED ENV{SDKROOT})
+    execute_process (
+      OUTPUT_VARIABLE sdktemp
+      ERROR_QUIET
+      COMMAND xcrun --sdk macosx --show-sdk-path
+      COMMAND tr -d "\n"
+    )
+    if (DEFINED sdktemp AND NOT sdktemp STREQUAL "")
+      set (ENV{SDKROOT} ${sdktemp})
+    endif()
+  endif()
 endif()
 
 #### compile options
@@ -272,6 +277,7 @@
   SYSTEM
   # for macos
   /opt/local/include
+  /opt/homebrew/include
   # for freebsd
   /usr/local/include
   "${CMAKE_BINARY_DIR}"
@@ -281,6 +287,7 @@
 set (required_includes
   # for macos
   /opt/local/include
+  /opt/homebrew/include
   # for freebsd
   /usr/local/include
 )
@@ -417,6 +424,3 @@
   if (_args_setmntent_2)
     set (_args_setmntent 2)
   endif()
-endmacro()
-
-macro (checkPrototype_getfsstat hdr)
