=== debian/changelog ===
di (5.0.12-1) unstable; urgency=medium

  * New upstream version 5.0.12

 -- Michael Ablassmeier <abi@debian.org>  Sat, 22 Feb 2025 21:03:53 +0100

di (5.0.11-1) unstable; urgency=medium

  * New upstream version 5.0.11

 -- Michael Ablassmeier <abi@debian.org>  Sat, 22 Feb 2025 20:49:24 +0100

di (5.0.7-1) unstable; urgency=medium

  * New upstream version 5.0.7

 -- Michael Ablassmeier <abi@debian.org>  Wed, 12 Feb 2025 19:36:07 +0100
