## di 5.0.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -98,15 +98,19 @@
 macro (checkAddCompileFlag flag)
   # cmake caches every damned variable...
   # need a different variable for every test.
-  check_c_compiler_flag (${flag} cfchk${flag})
-  if (cfchk${flag})
+  string (REPLACE "-" "_" tflag ${flag})
+  string (REPLACE "=" "_" tflag ${tflag})
+  check_c_compiler_flag (${flag} cfchk${tflag})
+  if (cfchk${tflag})
     add_compile_options (${flag})
   endif()
 endmacro()
 
 macro (checkAddLinkFlag flag)
-  check_linker_flag ("C" ${flag} lfchk${flag})
-  if (lfchk${flag})
+  string (REPLACE "-" "_" tflag ${flag})
+  string (REPLACE "=" "_" tflag ${tflag})
+  check_linker_flag ("C" ${flag} lfchk${tflag})
+  if (lfchk${tflag})
     add_link_options (${flag})
   endif()
 endmacro()
@@ -293,7 +297,9 @@
 )
 
 set (CMAKE_REQUIRED_INCLUDES ${required_includes})
-add_compile_options (-DWIN32_LEAN_AND_MEAN=1)
+if (WIN32)
+  add_compile_options (-DWIN32_LEAN_AND_MEAN=1)
+endif()
 
 #### configuration
 
@@ -414,13 +420,3 @@
     )
   check_prototype_definition (setmntent
     "FILE * setmntent (const char * a, const char * b)"
-    "NULL"
-    "stdio.h;stddef.h;${hdr}"
-    _args_setmntent_2
-    )
-  if (_args_setmntent_1)
-    set (_args_setmntent 1)
-  endif()
-  if (_args_setmntent_2)
-    set (_args_setmntent 2)
-  endif()
