=== debian/changelog ===
di (5.0.14-1) unstable; urgency=medium

  * New upstream version 5.0.14 (Closes: #1099509)

 -- Michael Ablassmeier <abi@debian.org>  Tue, 04 Mar 2025 18:44:26 +0100

di (5.0.13-1) unstable; urgency=medium

  * New upstream version 5.0.13

 -- Michael Ablassmeier <abi@debian.org>  Sat, 01 Mar 2025 22:01:00 +0100
