## di 6.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,6 @@
 
 SET (CMAKE_SKIP_BUILD_RPATH FALSE)
 SET (CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
-
 if (DEFINED ENV{CMAKE_SKIP_RPATH} AND NOT ENV{CMAKE_SKIP_RPATH} STREQUAL "")
   set (CMAKE_SKIP_RPATH "$ENV{CMAKE_SKIP_RPATH}")
 endif()
@@ -96,8 +95,6 @@
 #### compile options
 
 macro (checkAddCompileFlag flag)
-  # cmake caches every damned variable...
-  # need a different variable for every test.
   string (REPLACE "-" "_" tflag ${flag})
   string (REPLACE "=" "_" tflag ${tflag})
   check_c_compiler_flag (${flag} cfchk${tflag})
@@ -420,3 +417,8 @@
     )
   check_prototype_definition (setmntent
     "FILE * setmntent (const char * a, const char * b)"
+    "NULL"
+    "stdio.h;stddef.h;${hdr}"
+    _args_setmntent_2
+    )
+  if (_args_setmntent_1)
