=== Makefile ===
--- 
+++ 
@@ -143,6 +143,10 @@
 tar:
 	./utils/mktar.sh
 
+.PHONY: betatar
+betatar:
+	./utils/mktar.sh beta
+
 ###
 # cmake
 
@@ -159,7 +163,7 @@
 #   (passing -j w/o arguments, and *BSD complains)
 .PHONY: cmake-all
 cmake-all:
-	@case $$(uname -s) in \
+	@case `uname -s` in \
 	  CYGWIN*) \
 	    COMP=$(CC) \
 	    $(MAKE) -e cmake-unix; \
@@ -184,7 +188,7 @@
 
 .PHONY: cmakeclang
 cmakeclang:
-	case $$(uname -s) in \
+	case `uname -s` in \
 	  *BSD*) \
 	    COMP=$(CC) \
 	    $(MAKE) -e cmake-unix; \
@@ -309,19 +313,16 @@
 mkc-install-po:
 	-./utils/instpo.sh "`pwd`/po" $(INST_LOCALEDIR) "`pwd`/tmp"
 
+# -lintl and -liconv are removed, as those libraries are only needed
+# for the main di program, not to link with the library.
 .PHONY: mkc-install-pc
 mkc-install-pc: $(MKC_REQLIB)
 	test -d $(INST_PKGCDIR) || mkdir -p $(INST_PKGCDIR)
-	@dilibs="$${LDFLAGS_LIBS_APPLICATION} `cat $(MKC_REQLIB)`" ; \
-	dilibs="`echo $${dilibs} | \
-	    sed -e 's,-lintl,,g' \
-	    -e 's,-liconv,,g'`" ; \
 	cat di.pc.in | \
 	  sed -e 's,@CMAKE_INSTALL_PREFIX@,$(PREFIX),g' \
 	      -e 's,@CMAKE_INSTALL_FULL_INCLUDEDIR@,$(INCDIR),g' \
 	      -e 's,@CMAKE_INSTALL_FULL_LIBDIR@,$(LIBDIR),g' \
 	      -e 's,@DI_VERSION@,$(DI_VERSION),g' \
-	      -e "s~@DI_REQUIRED_LIBS@~$${dilibs}~" \
 	  > $(INST_PKGCDIR)/di.pc
 
 .PHONY: mkc-install-di
@@ -339,48 +340,12 @@
 .PHONY: mkc-install-libdi
 mkc-install-libdi:
 	test -d $(INST_LIBDIR) || mkdir -p $(INST_LIBDIR)
-	@sym=T ; \
-	instdest=$(INST_LIBDIR) ; \
-	case `uname -s` in \
-	  Darwin) \
-	    libnm=libdi.$(DI_LIBVERSION)$(SHLIB_EXT) ; \
-	    libnmso=libdi.$(DI_SOVERSION)$(SHLIB_EXT) ; \
-	    ;; \
-	  CYGWIN*|MSYS*|MINGW*) \
-	    instdest=$(INST_BINDIR) ; \
-	    libnm=libdi$(SHLIB_EXT) ; \
-	    sym=F ; \
-	    ;; \
-	  OpenBSD) \
-	    libnm=libdi$(SHLIB_EXT).$(DI_LIBVERSION) ; \
-	    libnmso=libdi$(SHLIB_EXT).$(DI_SOVERSION) ; \
-	    sym=O ; \
-	    ;; \
-	  *) \
-	    libnm=libdi$(SHLIB_EXT).$(DI_LIBVERSION) ; \
-	    libnmso=libdi$(SHLIB_EXT).$(DI_SOVERSION) ; \
-	    ;; \
-	esac ; \
-	cp -f libdi$(SHLIB_EXT) $${instdest}/$${libnm} ; \
-	if [ $$sym = T -o $$sym = O ]; then \
-	  ( \
-	    cd $(INST_LIBDIR) ; \
-	    ln -sf $${libnm} $${libnmso} ; \
-	  ) ; \
-	fi ; \
-	if [ $$sym = T ]; then \
-	  ( \
-	    cd $(INST_LIBDIR) ; \
-	    ln -sf $${libnmso} libdi$(SHLIB_EXT) ; \
-	  ) ; \
-	fi
-
+	./utils/instlibdi.sh "$(INST_LIBDIR)" "$(INST_BINDIR)" $(DI_LIBVERSION) $(DI_SOVERSION)
+
+# incorrect for netbsd
 .PHONY: mkc-install-man
 mkc-install-man:
-	-test -d $(INST_MANDIR)/man1 || mkdir -p $(INST_MANDIR)/man1
-	cp -f man/di.1 $(INST_MANDIR)/man1/$(MAN_TARGET)
-	-test -d $(INST_MANDIR)/man3 || mkdir -p $(INST_MANDIR)/man3
-	cp -f man/libdi.3 $(INST_MANDIR)/man3/$(MAN_TARGET)
+	./utils/instman.sh "$(PREFIX)" "$(MANDIR)"
 
 ###
 # mkc environment
@@ -519,3 +484,18 @@
 dioptions.o: config.h
 dioptions.o: di.h disystem.h
 dioptions.o: diinternal.h
+dioptions.o: dimath.h dioptions.h getoptn.h
+dioptions.o: distrutils.h
+diquota.o: config.h
+diquota.o: di.h
+diquota.o: disystem.h dimath.h
+diquota.o: diquota.h diinternal.h dioptions.h
+diquota.o: getoptn.h distrutils.h
+distrutils.o: config.h
+distrutils.o: distrutils.h
+dizone.o: config.h
+dizone.o: di.h dizone.h disystem.h
+dizone.o: dioptions.h getoptn.h distrutils.h
+getoptn.o: config.h
+getoptn.o: disystem.h
+getoptn.o: distrutils.h getoptn.h
