=== debian/changelog ===
di (6.0.0-1) unstable; urgency=medium

  * New upstream version 6.0.0
  * Rename libdi5 to libdi6 to match new library version.
  * Move man page for libdi to -dev package, add conflict entry to
    debian/control.

 -- Michael Ablassmeier <abi@debian.org>  Mon, 10 Mar 2025 20:12:23 +0100
