=== debian/control ===
--- 
+++ 
@@ -27,13 +27,14 @@
 
 Package: libdi-dev
 Architecture: any
-Depends: libdi5 (= ${binary:Version}), ${misc:Depends}
+Depends: libdi6 (= ${binary:Version}), ${misc:Depends}
 Section: libdevel
+Conflicts: libdi5
 Description: Header files for libdi
  Development files for libdi, a shared library that can be used to get disk
  space or percentages.
 
-Package: libdi5
+Package: libdi6
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}
