=== debian/watch ===
version=4
https://sf.net/diskinfo-di/ di-@ANY_VERSION@@ARCHIVE_EXT@
